Sonar Analysis:
  image: 
  services:
    - docker:19.03.5-dind
  variables:
    #EdgeAI Runners
    DOCKER_DRIVER: overlay
    DOCKER_HOST: tcp://localhost:2375
    DOCKER_TLS_CERTDIR: ""  
  stage: scan
  allow_failure: true
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH == 'staging'
  script:
    - touch sonar.html
    - echo ${SONAR_PROJECT_KEY}
    - export CI_COMMIT_REF_NAME=${CI_COMMIT_REF_NAME:=CI_COMMIT_REF_NAME}
    - export SONAR_TOKEN=${SONAR_TOKEN:=SONAR_TOKEN}
    - export SONAR_LANGUAGE=${SONAR_LANGUAGE:=SONAR_LANG}
    - export SONAR_PROJECT_BASE_DIR=${SONAR_PROJECT_BASE_DIR:=.}
    - export SONAR_BINARIES=${SONAR_BINARIES:=**/*}
    - export BUILD_BREAKER_SKIP=${BUILD_BREAKER_SKIP:-true}
    - export QUALITY_GATE=${QUALITY_GATE:-false}
    - echo "Build Breaker Skip" ${BUILD_BREAKER_SKIP}
    - echo "Quality Gate Check" ${QUALITY_GATE}
    - sonar-scanner -Dsonar.issuesReport.html.enable=true -Dsonar.sources=. -Dsonar.tests=test -Dsonar.test.inclusions=**/*.test.js -Dsonar.exclusions=**/test/**,**/coverage/**,**/util/**,**/routes/**,**/vson-coverage/**,**/log/**,**/index.js,**/app.js -Dsonar.javascript.lcov.reportPath=coverage/lcov.info -Dsonar.javascript.lcov.reportPaths=coverage/lcov.info -Dsonar.language=${SONAR_LANGUAGE} -Dsonar.buildbreaker.skip=${BUILD_BREAKER_SKIP} -Dsonar.login=${SONAR_TOKEN}  -Dsonar.projectKey=${SONAR_PROJECT_KEY} -Dsonar.projectVersion=${CI_COMMIT_REF_NAME}  -Dsonar.sources=. -Dsonar.testExecutionReportPaths=${SONAR_PROJECT_BASE_DIR}/report.xml -Dsonar.projectBaseDir=${SONAR_PROJECT_BASE_DIR} -Dsonar.sourceEncoding=UTF-8 -Dsonar.analysis.mode=publish -Dsonar.dynamicAnalysis=reuseReports -Dsonar.issuesReport.console.enable=true -Dsonar.host.url=-Dsonar.qualitygate.wait=${QUALITY_GATE}
